package br.com.rjconsultores.auditador.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Anotação utilizada para methodos.
 * 
 * @author wilian
 *
 */
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface AuditarMetodo {
	
	/**
	 * Caso seja necessário colocar um nome amigável para o atributo, seNão for informado o padrão será o nome do atributo da classe.
	 */
	String nome() default "";
	
	/**
	 * Em caso de um atributo do tipo "DATE", informar o formato da data, valor padrão: "dd/MM/yyyy HH:mm"
	 */
	String pattern() default "dd/MM/yyyy HH:mm";

}
