package com.rjconsultores.ventaboletos.blocos.safra;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import com.rjconsultores.ventaboletos.blocos.DetalheRetorno;
import com.rjconsultores.ventaboletos.enuns.MotivoOcorrenciaBradesco;
import com.rjconsultores.ventaboletos.enuns.OcorrenciaBradesco;

public class DetalheRetornoSafra implements DetalheRetorno, Cloneable{

	private String numeroControleDoParticipante;
	private OcorrenciaBradesco ocorrencia;
	private List<MotivoOcorrenciaBradesco> motivoOcorrencias;
	private Integer idBoletoFechamento;
	private String nossoNumero;
	private String codigoOcorrencia;
	private String dataBaixa;
	private BigDecimal valorJuros;
	private Integer numeroSequencialRegistro;
	
	public String getNumeroControleDoParticipante() {
		return numeroControleDoParticipante;
	}
	
	public void setNumeroControleDoParticipante(String numeroControleDoParticipante) {
		this.numeroControleDoParticipante = numeroControleDoParticipante;
	}
	
	public OcorrenciaBradesco getOcorrencia() {
		return ocorrencia;
	}
	
	public void setOcorrencia(OcorrenciaBradesco ocorrencia) {
		this.ocorrencia = ocorrencia;
	}
	
	public List<MotivoOcorrenciaBradesco> getMotivoOcorrencias() {
		return motivoOcorrencias;
	}
	
	public void addMotivoOcorrencia(MotivoOcorrenciaBradesco motivoOcorrencias) {
		
		if(this.motivoOcorrencias == null){
			this.motivoOcorrencias = new ArrayList<MotivoOcorrenciaBradesco>();
		}
		
		this.motivoOcorrencias.add(motivoOcorrencias);
	}
	
	public Integer getIdBoletoFechamento() {
		return idBoletoFechamento;
	}
	
	public void setIdBoletoFechamento(Integer idBoletoFechamento) {
		this.idBoletoFechamento = idBoletoFechamento;
	}
	
	public String getNossoNumero() {
		return nossoNumero;
	}
	
	public void setNossoNumero(String nossoNumero) {
		this.nossoNumero = nossoNumero;
	}
	
	public Integer getNumeroSequencialRegistro() {
		return numeroSequencialRegistro;
	}
	
	public void setNumeroSequencialRegistro(Integer numeroSequencialRegistro) {
		this.numeroSequencialRegistro = numeroSequencialRegistro;
	}
	
	public void setMotivoOcorrencias(List<MotivoOcorrenciaBradesco> motivoOcorrencias) {
		this.motivoOcorrencias = motivoOcorrencias;
	}

	public String getCodigoOcorrencia() {
		return codigoOcorrencia;
	}

	public void setCodigoOcorrencia(String codigoOcorrencia) {
		this.codigoOcorrencia = codigoOcorrencia;
	}
	
	public BigDecimal getValorJuros() {
		return valorJuros;
	}

	public void setValorJuros(BigDecimal valorJuros) {
		this.valorJuros = valorJuros;
	}
	
	public String getDataBaixa() {
		return dataBaixa;
	}

	public void setDataBaixa(String dataBaixa) {
		this.dataBaixa = dataBaixa;
	}
	
}
