package com.rjconsultores.ventaboletos.enuns;

import java.util.ArrayList;
import java.util.List;

public enum BancoLayout {
	BB_240_Envio("001", "Banco do Brasil", false, "/layouts/LayoutBBCNAB240Envio.txg.xml", true),
	BRADESCO_400_Envio("237", "Bradesco", false, "/layouts/LayoutBradescoCNAB400Envio.txg.xml", true),
	CAIXA_400_Envio("104", "Caixa Econômica Federal", false, "/layouts/LayoutCaixaCNAB400Envio.txg.xml", true),
	ITAU_400_Envio("341", "Itaú", false, "/layouts/LayoutItauCNAB400Envio.txg.xml", true),
	MERCANTIL_400_Envio("389", "Mercantil", false, "/layouts/LayoutMercantilCNAB400Envio.txg.xml", true),	
	SANTANDER_400_Envio("033", "Santander", false, "/layouts/LayoutSantanderCNAB400Envio.txg.xml", true),	
	SAFRA_400_Envio("422", "Safra", false, "/layouts/LayoutSafraCNAB400Envio.txg.xml", true),
	SICOOB_240_Envio("756", "Sicoob", false, "/layouts/LayoutSicoobCNAB240Envio.txg.xml", true),
	
	
	SANTANDER_400_Retorno("033", true, "/layouts/LayoutSantanderCNAB400Retorno.txg.xml"),
	BRADESCO_400_Retorno("237", true, "/layouts/LayoutBradescoCNAB400Retorno.txg.xml"),
	ITAU_400_Retorno("341", true, ""),
	BB_240_Retorno("001", true, ""),
	SAFRA_400_Retorno("422", true, "/layouts/LayoutSafraCNAB400Retorno.txg.xml")
	
	;
	
	private BancoLayout(String codBanco, boolean retorno, String path) {
		this.codBanco = codBanco;
		this.retorno = retorno;
		this.descricao = "";
		this.path = path;
		this.suportado = false;
	}
	
	private BancoLayout(String codBanco, String descricao, boolean retorno, String path, boolean suportado) {
		this.codBanco = codBanco;
		this.retorno = retorno;
		this.descricao = descricao;
		this.path = path;
		this.suportado = suportado;
	}
	
	private String codBanco;
	private boolean retorno;
	private String path;
	private String descricao;
	private boolean suportado;
	
	public String getCodBanco() {
		return codBanco;
	}
	
	public boolean isRetorno() {
		return retorno;
	}
	
	public String getPath() {
		return path;
	}
	
	public String getTemp() {
		return path.substring(path.lastIndexOf("/"));
	}

	public String getDescricao() {
		return descricao;
	}

	public boolean isSuportado() {
		return suportado;
	}

	public static BancoLayout getInstanceByCodBanco(String codBanco){
		
		for(BancoLayout o : BancoLayout.values()){
			
			if(o.getCodBanco().equals(codBanco) && !o.isRetorno()){
				return o;
			}
		}
		
		return null;
	}
	
	public static List<String> getSuportados(){
		List<String> bancosSuportados = new ArrayList<>();
		
		for(BancoLayout o : BancoLayout.values()){			
			if(o.isSuportado()){
				bancosSuportados.add(o.getDescricao());
			}
		}
		
		return bancosSuportados;
	}
	
	public static String getCodigo(String descricao){			
		for(BancoLayout banco :BancoLayout.values()){
			if(banco.descricao.equals(descricao)){
				return banco.codBanco;
			}
		}			
		return null;			
	}
	
	public static String getDescricao(String codigo){			
		for(BancoLayout banco :BancoLayout.values()){
			if(banco.codBanco.equals(codigo)){
				return banco.descricao;
			}
		}			
		return null;			
	}
}
